/*************************************
 * This example is from https://github.com/Kongduino/RUI3_LoRa_P2P_PING_PONG
 * This example needs two devices, a device will send LoRa P2P package after receiving LoRa P2P package.
 *************************************/
extern const char *sw_version;

long startTime;
bool rx_done = false;
uint8_t setalart=0;
double myFreq = 921000000;//ch
//uint16_t sf = 12, bw = 0, cr = 0, preamble = 8, txPower = 22;
//技適 bw=0(125
uint16_t sf = 7, bw = 0, cr = 0, preamble = 8, txPower = 5;//5dbm=3.16mW 13dbm=19.95mW	特定小電力
uint8_t ledPin1 = LED_GREEN;
uint8_t ledPin2 = LED_BLUE;
uint8_t IO1 = LED_GREEN;//WB_IO1
uint8_t IO2 = LED_BLUE; //WB_IO2
uint8_t IO3 = WB_IO2;//PB6 WB_TXD0 dame?//uint8_t IO3 = WB_I2C1_SCL;


void recv_cb(rui_lora_p2p_recv_t data)
{
    char buff[100]="";
    char *temp;
    

    bool send_result = false;    
    int itemp;
    rx_done = true;
    if (data.BufferSize == 0) {
        Serial.println("Empty buffer.");
        //Serial.printf("P2P set Rx mode %s\r\n",api.lorawan.precv(65533) ? "Success" : "Fail");        //2重に送るとエラーになるから
        return;
    }
    //sprintf(buff, "Incoming message, length: %d, RSSI: %d, SNR: %d",data.BufferSize, data.Rssi, data.Snr);
    //Serial.println(buff);
    
    strncpy(buff, (char*)data.Buffer,data.BufferSize);
    buff[data.BufferSize]='\0';
    Serial.print(buff);//受信PCにスルーさせる

    if(!strncmp(buff, "8:", 2)){
      //Serial.println("data is 8");
      strtok(buff, ":");
      strtok(NULL, ",");//loraNo
      temp = strtok(NULL, ",");//区分
      //Serial.println(temp);
      /*
      setalart=0;
      if(!strncmp(temp, "1S", 2)){
        setalart=1;
      }
      if(!strncmp(temp, "2S", 2)){
        setalart=2;
      }
      if(!strncmp(temp, "3S", 2)){
        setalart=3; 
      }
*/
      if(!strncmp(temp, "1S", 2)){
        digitalWrite(IO1, LOW);
        digitalWrite(IO2, LOW);
        digitalWrite(IO3, LOW);
      }
      if(!strncmp(temp, "2S", 2)){
        digitalWrite(IO1, HIGH);
        digitalWrite(IO2, LOW);
        digitalWrite(IO3, LOW);        
      }
      if(!strncmp(temp, "3S", 2)){
        digitalWrite(IO1, LOW);
        digitalWrite(IO2, HIGH);
        digitalWrite(IO3, LOW);        
      }
      
    }
}
/*
void send_cb(void)
{
   //Serial.printf("P2P set Rx mode %s\r\n",api.lorawan.precv(65533) ? "Success" : "Fail");
}
*/
void setup()
{
    pinMode(IO1, OUTPUT);
    pinMode(IO2, OUTPUT);
    pinMode(IO3, OUTPUT);
    digitalWrite(IO1, LOW);
    digitalWrite(IO2, LOW);
    digitalWrite(IO3, LOW);


//    Serial.begin(115200);
    Serial.begin(115200,RAK_AT_MODE);
    Serial.println("RAKwirel wintablet_v4_sleepall");
    Serial.println("-----------------------");
    delay(4500);//boot チャンス
    startTime = millis();
    
    if(api.lorawan.nwm.get() != 0)
    {
        Serial.printf("Set Node device work mode %s\r\n",
            api.lorawan.nwm.set(0) ? "Success" : "Fail");
        api.system.reboot();
    }

    Serial.println("P2P Start");
    Serial.printf("Hardware ID: %s\r\n", api.system.chipId.get().c_str());
    Serial.printf("Model ID: %s\r\n", api.system.modelId.get().c_str());
    Serial.printf("RUI API Version: %s\r\n",
  		api.system.apiVersion.get().c_str());
//    Serial.printf("Firmware Version: %s\r\n",	api.system.firmwareVersion.get().c_str());
    Serial.printf("Firmware Version: %s\r\n",sw_version);
    Serial.printf("AT Command Version: %s\r\n",
  		api.system.cliVersion.get().c_str());
    Serial.printf("Set P2P mode frequency %3.3f: %s\r\n", (myFreq / 1e6),
  		api.lorawan.pfreq.set(myFreq) ? "Success" : "Fail");
    Serial.printf("Set P2P mode spreading factor %d: %s\r\n", sf,
  		api.lorawan.psf.set(sf) ? "Success" : "Fail");
    Serial.printf("Set P2P mode bandwidth %d: %s\r\n", bw,
  		api.lorawan.pbw.set(bw) ? "Success" : "Fail");
    Serial.printf("Set P2P mode code rate 4/%d: %s\r\n", (cr + 5),
  		api.lorawan.pcr.set(cr) ? "Success" : "Fail");
    Serial.printf("Set P2P mode preamble length %d: %s\r\n", preamble,
  		api.lorawan.ppl.set(preamble) ? "Success" : "Fail");
    Serial.printf("Set P2P mode tx power %d: %s\r\n", txPower,
  		api.lorawan.ptp.set(txPower) ? "Success" : "Fail");
    api.lorawan.registerPRecvCallback(recv_cb);
    Serial.printf("P2P set precv65533 %s\r\n",api.lorawan.precv(65533) ? "Success" : "Fail");


}

void serial_read_line(char buf[], int n){
  int i = 0, input;
  
  while(1){
    input = Serial.read();
    if ( input == -1 ) continue;
    if ( input == int('\n') ) {
      buf[i] = '\0';
      return;
    }
    buf[i] = input;
    i++;
    if ( i >= n-1 ) {
      buf[n-1] = '\0';
      return;
    }
  }
}



void loop()
{
  api.system.sleep.all();
}
